/*************************************************************************
Title:    Debug Test mit AT90S2313
Author:   Original von s b i s s o n n e t t e  at  microsyl do t  c o m
Author2:  Angepasst an WinAVR von Harry Skountzos
File:     $Id: debug_test.c,v 1.7 2007/04/16 06:45:00
Software: AVR-GCC 4.1.1 WinAVR 20070122
Hardware: ATS90S2313 + TTL->RS 232 Adapter
**************************************************************************/
#include "suart.h"
#include <util/delay.h>
	#include <stdlib.h>
	#include <avr/io.h>

	 #define DEBUG_DDR 	DDRB
	 #define DEBUG_PORT	PORTB
	 #define DEBUG_BIT	PB2

//Wartezeit in us 
//   #define MINDELAY		104   	// fuer 9600 bps
//#define MINDELAY		95 //Fr diesen Chip ;) @ 4,8MHz
#define MINDELAY		100 //Fr diesen Chip ;) @ 9,6MHz
// #define MINDELAY		26 		// fuer 38400 bps
// #define MINDELAY 	417		// fuer 2400 bps ACHTUNG nicht mit _delay_us machtbar!!
								// zumindest nicht als einzelner aufruf!

//
// Recht genaue Pausen-Routine fr den ms Bereich
//
void pause_ms(unsigned int  ms) {
	unsigned int zaehler;
	
	while (ms) {
		zaehler = F_CPU / 5000;
		
		while (zaehler) {
			asm volatile ("nop");
			zaehler--;
		}
		ms--;
	}
}


//
// Debug mit ANSI Steuerung fuer die Position!
// pos 0,0 Loescht den Bildschirm !
//

void DebugXY(unsigned char x, unsigned char y,  char *Ptr) {
	char Buffer[10];

	if (x == 0 && y == 0) {
		Debug("\x1b[2J\0");
		Debug("\x1b[1;1H\0");
	} else {
	  Buffer[0] = 0x1b;
	  Buffer[1] = '[';
	  Buffer[2] = (y/10)+48;
	  Buffer[3] = (y%10)+48;
	  Buffer[4] = ';';
	  Buffer[5] = (x/10)+48;
	  Buffer[6] = (x%10)+48;
	  Buffer[7] = 'f';
	  Buffer[8] = 0x00;
	  Debug(&Buffer[0]);
	  Debug(Ptr);
	}
}

void Debug_c(uint8_t c) {
	unsigned char i;

DEBUG_PORT &= ~_BV(DEBUG_BIT);
	_delay_us(MINDELAY); // Start Bit

	for(i = 0; i < 8; i++) { // Alle 8 Bits
			if(c & (0x01<<i)) {
				DEBUG_PORT |= _BV(DEBUG_BIT);
				_delay_us(MINDELAY);
			} else {
				DEBUG_PORT &= ~_BV(DEBUG_BIT);
				_delay_us(MINDELAY);
			}
		}
	
	DEBUG_PORT |= _BV(DEBUG_BIT); // Stop Bit
		_delay_us(MINDELAY);

}

/* 	Beliebigen Port wird als Ausgang konfiguriert und dann per Software UART 
	verwendet. In dem Beispiel wird der normale txd Anschlu genutzt aufgrund 
	der Hardwarebeschaltung auf meiner Platine 
	nutzt die _delay_us der AVRLib */

void Debug(char *Ptr) {

								
	//unsigned char i;

	DEBUG_DDR |= _BV(DEBUG_BIT); // Port als Ausgang
	DEBUG_PORT |= _BV(DEBUG_BIT); // Port mit HIGH vorbelegen

	while(*Ptr) {
		Debug_c(*Ptr);


		
		Ptr++;
	}
}


void printnum(uint8_t num) {
	char str_buffer[10];
	uint8_t i = 0;
	itoa(num, str_buffer, 10);
	while(str_buffer[i] != 0) {
		Debug_c(str_buffer[i]);
		i++;
	}
}


